Bug 242607 - Build with festival error.
Build with festival error.
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: festival (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Zeuthen
: FutureFeature, Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-06-04 21:36 EDT by Hu Zheng
Modified: 2012-10-30 10:15 EDT (History)
10 users (show)

See Also:
Fixed In Version: festival-1.96-18.fc14
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
: 483777 (view as bug list)
Environment:
Last Closed: 2011-03-03 03:23:30 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
undefined-non-weak-symbol_festival-lib-1.96-7.fc10.x86_64.log (50.60 KB, text/plain)
2009-01-22 11:53 EST, Nicolas Chauvet (kwizart)
no flags Details
Patch to move files (2.84 KB, patch)
2011-01-11 13:19 EST, Tim Niemueller
no flags Details | Diff
fix backtrace variable problem. (4.33 KB, patch)
2012-01-13 04:40 EST, Hu Zheng
no flags Details | Diff

  None (edit)
Description Hu Zheng 2007-06-04 21:36:13 EDT
StarDict is using festival. It build on FC6 well ago, but in the newest
Fedora 7 version. It can't build.

svn co https://svn.sourceforge.net/svnroot/stardict/trunk stardict

You can modify configure.in:
FESTIVAL_CFLAGS="-I/usr/include/speech_tools -ffriend-injection
-Wno-deprecated"

./autogen.sh
make

But there will be many error such as:
/usr/include/speech_tools/ling_class/EST/EST_Relation.h:48:33: error:
ling_class/EST_Item.h: No such file or directory
As the real file is: ling_class/EST/EST_Item.h, so you need to change
the directory structure, or modify the header files.
Comment 1 Hu Zheng 2007-06-22 04:35:17 EDT
Do you have time to fix this recently? I hope it can be done soon, thank you!
Comment 2 Matthew Miller 2007-06-25 15:19:06 EDT
Hmm, actually, I think I fixed this already in the newer versions of the
packages I'm working on. I made a few other changes too. Can you test with these
packages:

http://mattdm.org/misc/festival/RPMS/

to see if they work for you?
Comment 3 Hu Zheng 2007-06-25 23:10:15 EDT
Yeah, the compile error is fixed. Thank you! :)

But there is a crash error:
#0  0x002ae7c2 in leval () from /usr/lib/libestools.so.1.2.96.1
#1  0x002b5760 in vload () from /usr/lib/libestools.so.1.2.96.1
#2  0x008bcac8 in festival_load_default_files () from /usr/lib/libFestival.so.1.96.0
#3  0x008bec55 in festival_initialize () from /usr/lib/libFestival.so.1.96.0

svn co https://svn.sourceforge.net/svnroot/stardict/trunk stardict
./autogen.sh
make
make install

To prevent the crash, you can "rm /usr/lib/stardict/plugins/stardict_festival.so".

Thank you!
Comment 4 Hu Zheng 2007-08-22 02:54:22 EDT
Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread -1208796928 (LWP 22034)]
0x004257b2 in leval (x=0xb729c6b8, env=0x0) at slib.cc:1347
1347     backtrace = cons(x,backtrace);
(gdb) bt
#0  0x004257b2 in leval (x=0xb729c6b8, env=0x0) at slib.cc:1347
#1  0x0042c750 in vload (fname_raw=0x84d0614 "/usr/share/festival/lib/init.scm",
cflag=0) at slib_file.cc:654
#2  0x002f7a88 in festival_load_default_files () at festival.cc:305
#3  0x002f9c15 in festival_initialize (load_init_files=1, heap_size=210000) at
festival.cc:106
#4  0x002024f8 in stardict_tts_plugin_init (obj=0x84ca9f8) at
stardict_festival.cpp:109
Comment 5 Hu Zheng 2008-01-03 02:34:13 EST
Hi! I get the reason that why link to festival library will cause crash:
The symbol "backtrace" in libestools.so will be mixed up with the same one in libc.
So, we can change the backtrace variable to static or just rename it.
Can you fix it and update festival in yum?
Comment 6 Zhang Le 2008-01-03 03:40:32 EST
Please give due credit, ;)
Thanks!
http://linuxsir.org/bbs/thread316576.html
Comment 7 Matthew Miller 2008-01-03 06:59:10 EST
Thanks, I'll fix the problem in my build. I have no control over fedora
releases, though.
Comment 8 Thomas Moschny 2008-04-22 14:41:04 EDT
(In reply to comment #0)
> [...]
> But there will be many error such as:
> /usr/include/speech_tools/ling_class/EST/EST_Relation.h:48:33: error:
> ling_class/EST_Item.h: No such file or directory
> As the real file is: ling_class/EST/EST_Item.h, so you need to change
> the directory structure, or modify the header files.

Ping... What is the status of the original bug?
Would be nice if it could be fixed.

Latest festival development rpms from rawhide (almost f9) still show similar 
problems with the directory layout for the include files.
Comment 9 Bug Zapper 2008-05-14 08:49:03 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Stefan Schiffer 2008-05-18 11:17:09 EDT
(In reply to comment #8)
> > [...]
> > But there will be many error such as:
> > /usr/include/speech_tools/ling_class/EST/EST_Relation.h:48:33: error:
> > ling_class/EST_Item.h: No such file or directory
> > As the real file is: ling_class/EST/EST_Item.h, so you need to change
> > the directory structure, or modify the header files.
> 
> Ping... What is the status of the original bug?
> Would be nice if it could be fixed.
> 
> Latest festival development rpms from rawhide (almost f9) still show similar 
> problems with the directory layout for the include files.

Can anyone report on the status (of the original bug) again?

The problem still shows up on current Fedora 9. Specifically, it rests in
speech_tools-devel. It appears as soon as you include
/usr/include/speech_tools/EST.h (included from festival.h). EST.h refers to
headers that include stuff in the form "subdir/EST_filename.h" but the original
file is actually located in "subdir/EST/EST_filename.h". This holds for all
subdirs in speech_tools. So possible resolutions would be to either fix the
includes or to remove the additional EST subdir in all speech_tools-subdirectories.

Is there anything I could do to help get this bug resolved?
Comment 11 Matthew Miller 2008-05-18 11:56:37 EDT
See comment #2. I've made several requests to become a comaintainer of the
festival package, but got no answer back. So I haven't worked on it for a while.
Comment 12 Tim Niemueller 2008-05-18 17:44:05 EDT
Why don't you contact David Zeuthen personally to get this cleared. Otherwise
cvsextras commit ACL is set, so you could just go ahead and change it, but
contacting David first is probably a good idea!
Comment 13 Matthew Miller 2008-05-18 17:47:18 EDT
Tim, that's what I did. So, uh, yes, good idea.
Comment 14 Tim Niemueller 2008-05-18 17:52:20 EDT
Tried fedora-devel-list? Maybe David is just too busy and someone else can help
to get this fixed quickly.
Comment 15 Thomas Moschny 2008-06-28 12:48:24 EDT
Why is this bug assigned to you, Matthew, and not to David?

Do you already have a patch that applies to the current version in fedora? If
so, you could attach it here, so we can test and/or discuss and finally apply
it, probably after trying to contact David again. Did you send a mail to the
fedora-devel list?

I'd really like to see this fixed, because festival will be used by lmms (see
bug 443771).
Comment 16 Mamoru TASAKA 2008-07-21 03:32:18 EDT
Just a note:

As I see package database, festival is open to cvsextras groupcommit.
Comment 17 Rakesh Pandit 2008-09-03 12:16:20 EDT
@Mathhew
need your response regarding #15? Are you reviewing the request ?
Comment 18 Matthew Miller 2008-09-03 14:18:09 EDT
I can't tackle this right now. However, if there's still no action in a couple of weeks I will try and make some time.
Comment 19 Matthias Clasen 2008-09-04 17:25:53 EDT
Matt, I just got David to approve your comaintainership for festival.
So whenever you have time, feel free to go ahead with further improvements to the package. I don't expect David to have time for festival anytime soon...
Comment 20 Matthew Miller 2008-09-04 20:03:50 EDT
Thanks Matthias. I'd gotten a little burned out on it, but I do have good improvements waiting in the wings.
Comment 21 Fedora Update System 2008-11-13 09:18:10 EST
festival-1.96-5.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/festival-1.96-5.fc9
Comment 22 Fedora Update System 2008-11-14 07:47:05 EST
festival-1.96-5.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update festival'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2008-9656
Comment 23 Fedora Update System 2008-12-02 20:13:05 EST
festival-1.96-5.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Fedora Update System 2009-01-09 08:52:27 EST
festival-1.96-7.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/festival-1.96-7.fc10
Comment 25 Fedora Update System 2009-01-14 21:52:28 EST
festival-1.96-7.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update festival'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-0365
Comment 26 Nicolas Chauvet (kwizart) 2009-01-22 11:53:33 EST
Created attachment 329721 [details]
undefined-non-weak-symbol_festival-lib-1.96-7.fc10.x86_64.log

There are lot of undefined-non-weak-symbol_festival
in the festival-lib-1.96-7.fc10 package (running rpmlint fastival-lib on installed package).

Theses symbols should be added at link time and could be the reason of runtime failures when the needed libraries aren't present at runtime. It will also prevents the linker to preload suches libraries which will degrade performances when loading. (since every symbol will be revolved at runtime).
Comment 27 Tim Niemueller 2009-02-05 04:38:25 EST
Please post your log to bug #470995 which is the appropriate one. This bug was about the broken headers (misplaced files).
Comment 28 Tim Niemueller 2009-02-05 04:39:30 EST
Send too early Actually your problem can be solved with the mentioned bug in one go, but they are still slightly different. New bug or make the mentioned bug a "catch all symbol problems" one?
Comment 29 Nicolas Chauvet (kwizart) 2009-02-05 04:47:43 EST
(In reply to comment #28)
> Send too early Actually your problem can be solved with the mentioned bug in
> one go, but they are still slightly different. New bug or make the mentioned
> bug a "catch all symbol problems" one?

which was done here:
https://bugzilla.redhat.com/show_bug.cgi?id=483777
Comment 30 Fedora Update System 2009-02-07 17:23:18 EST
festival-1.96-7.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 31 Nicolas Chauvet (kwizart) 2009-03-02 09:59:32 EST
Since this bug have been addressed and the package is available in the stable updates, I think this bug can be closed. 
Please report #483777 upstream for advices...(usually some library flags could be added at link time).
Comment 32 Tim Niemueller 2011-01-11 09:35:36 EST
The problem still persists.

--- Compiling synth_thread.cpp (C++)
In file included from /usr/include/speech_tools/EST.h:43:0,
                 from /usr/include/festival/festival.h:47,
                 from /home/tim/robotics/fawkes/src/plugins/festival/synth_thread.cpp:28:
/usr/include/speech_tools/EST_system.h:56:38: fatal error: unix/EST_defines_unix.h: No such file or directory
compilation terminated.
make[1]: *** [synth_thread.o] Error 1

The problem is that /usr/include/speech_tools/EST/EST_defines_unix.h should reside at /usr/include/speech_tools/EST_defines_unix.h. Would a spec patch be accepted into the package? I had fixed this once in the cvs repository, but the change was overwritten later on.
Comment 33 Tim Niemueller 2011-01-11 13:19:52 EST
Created attachment 472864 [details]
Patch to move files

This patch re-introduces the changes made in CVS. It moves the files to the appropriate locations after installation. Software using festival.h header compiles afterwards.
Patch can be applied with "git am".
Comment 34 Tim Niemueller 2011-02-14 03:34:43 EST
David, I have requested commit access to the package so I can apply the fix. Can you please approve?
Comment 35 Nicolas Chauvet (kwizart) 2011-02-22 03:47:02 EST
Any improvements for this bug ?
Comment 36 Tim Niemueller 2011-02-22 07:50:59 EST
Situation is currently being resolved, cf. fedora-devel list by the nonresponsive maintainer process (which we do not need to initiate as it seems). I have now commit permissions and commited the fix for this bug. I will now build in Koji and push updates. From there we can go on.

Is anyone here who worked on the package in the past and is interested in having a look at the latest upstream release 2.1, in particular which of the 19 patches and numerous sources are still required, which have been upstreamed, and which should be upstreamed? I'd really like to see this package in a better shape with far less patches, closer to upstream, and not being a de-facto in-package fork.
Comment 37 Fedora Update System 2011-02-22 08:26:01 EST
festival-1.96-18.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/festival-1.96-18.fc14
Comment 38 Fedora Update System 2011-02-22 08:26:31 EST
festival-1.96-18.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/festival-1.96-18.fc15
Comment 39 Fedora Update System 2011-02-22 13:48:51 EST
festival-1.96-18.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update festival'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/festival-1.96-18.fc14
Comment 40 Fedora Update System 2011-03-02 22:35:34 EST
festival-1.96-18.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 41 Fedora Update System 2011-03-03 03:23:23 EST
festival-1.96-18.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 42 Hu Zheng 2012-01-13 04:40:41 EST
Created attachment 555021 [details]
fix backtrace variable problem.

libc also has a variable called backtrace, so change this one to backtrace1, or may cause crash problem.
Comment 43 Hu Zheng 2012-01-13 04:42:57 EST
Fixed load stardict festival plugin crash problem by change backtrace variable to backtrace1.

But there is still a problem when using stardict festival plugin.
=====
SIOD ERROR: ran out of storage 

Program received signal SIGSEGV, Segmentation fault.
gc_mark (ptr=0x4) at slib.cc:1121
=====

Who can try to solve this problem?
Comment 44 Hu Zheng 2012-01-15 06:39:33 EST
Seems segmentation fault problem disappeared after I reboot my system!

Can anyone merge the backtrace patch and update the rpm in Fedora? It is important for stardict program!
Comment 45 Hu Zheng 2012-10-30 07:10:46 EDT
Can anyone merge the backtrace patch and update the rpm in Fedora?
Comment 46 Matthew Miller 2012-10-30 10:15:03 EDT
(In reply to comment #45)
> Can anyone merge the backtrace patch and update the rpm in Fedora?

Hi, and sorry -- it's been years since I've worked on Festival but I'll try to help out since it's in bad shape. Give me a little bit to get back up to speed.

Note You need to log in before you can comment on or make changes to this bug.